//+------------------------------------------------------------------+
//|                                                  eurgbpusd15.mq4 |
//|                                                      Ian peasley |
//|                                        http://www.ad4profits.com |
//|   Does well on the eur/usd,gbp/usd,and usd/cad 15min chart as    |
//|   as the eur/usd daily chart                                     |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, Ian peasley"
#property link      "http://www.ad4profits.com"

//---- input parameters
extern int       TakeProfit = 50;
extern int       StopLoss = 20;
extern int       TrailingStop = 11;
extern double    Lots = 0.1;
extern int       per_EMA5 = 3;
extern int       per_EMA20 = 5;
extern int       per_EMA30 = 13;
extern int       per_EMA40 = 21;
extern int       per_EMA60 = 80;
extern int       RSI = 21;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
//  
int total, cnt, Buy=0, Sell=0;
double EMA5, EMA20, EMA30, EMA40, EMA60, RSI;
int err;

//        

  EMA5 = iMA(NULL,0,per_EMA5,0,MODE_EMA,PRICE_MEDIAN,1);
  EMA20 = iMA(NULL,0,per_EMA20,0,MODE_EMA,PRICE_MEDIAN,1);
  EMA30 = iMA(NULL,0,per_EMA30,0,MODE_EMA,PRICE_MEDIAN,2);
  EMA40 = iMA(NULL,0,per_EMA40,0,MODE_EMA,PRICE_MEDIAN,1);
  EMA60 = iMA(NULL,0,per_EMA60,0,MODE_EMA,PRICE_MEDIAN,1);
  RSI = iRSI (NULL, 0, 21, PRICE_CLOSE,0 ); 
    total=OrdersTotal();

  //  
  if(AccountFreeMargin()<(1000*Lots))
     {
       Print("We have no money. Free Margin = ", AccountFreeMargin());   
       return(0);  
     }
 //if(total<1)
 // { 
  //     
  if(Buy<1 && EMA5>EMA20 && EMA5>EMA30 && EMA5>EMA40 && EMA20>EMA30 && EMA20>EMA40 && EMA30>EMA60 && EMA40>EMA60 && (EMA40-EMA60)>=0.0001 && RSI>=50)  
     {
            Print("BUY EMA40 = ",EMA40 ," EMA60 = ", EMA60 ," EMA30 = ",EMA30);
            OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Bid-StopLoss*Point,Ask+TakeProfit*Point,"",16384,0,Green);
            Buy=1;
            //return(0);
     }

  if(Sell<1 && EMA5<EMA20 && EMA5<EMA30 && EMA5<EMA40 && EMA20<EMA30 && EMA20<EMA40 && EMA30<EMA60 && EMA40<EMA60 &&(EMA60-EMA40)>=0.0001 && RSI<=50) 
     {
            Print("SELL EMA40 = ",EMA40 ," EMA60 = ", EMA60 ," EMA30 = ",EMA30);
            OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Ask+StopLoss*Point,Bid-TakeProfit*Point,"",16385,0,Red);
            Sell=1;
            //return(0);
     }
 // }     
  for(cnt=total-1;cnt>=0;cnt--)
     {
       OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
       if(OrderType()==OP_BUY)
         { 
           if(EMA40<=EMA60)
             {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
               Buy=0;
//               return(0); // exit
             }
           if(TrailingStop>0)  
             {                 
               if(Bid-OrderOpenPrice()>Point*TrailingStop) // Bid -  
                 {
                   if(OrderStopLoss()<Bid-Point*TrailingStop)
                     {
                       OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green);
                       //return(0);
                     }
                 }
             }
         }
       if(OrderType()==OP_SELL)
         {
           if(EMA40>=EMA60)
             {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Violet); // close position
               Sell=0;
//               return(0); // exit
             }
           if(TrailingStop>0)  
             {                 
               if((OrderOpenPrice()-Ask)>(Point*TrailingStop))  // Ask -  
                 {
                   if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                     {
                       OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red);
                       //return(0);
                     }
                 }
             }
         }
     }
     
   
//----
   return(0);
  }
//+------------------------------------------------------------------+